close all;
clear all;

load('result_PCE.mat');

%==============================================================================
% ------------------Computing Sample Parameter Moments -----------------------------
%==========================================================================

smoothprob=mean(SMM,2);
p00=mean(p00MM,2);
p11=mean(p11MM,2);
LS0=mean(LS0MM,3);
LS1=mean(LS1MM,3);
rhoS0=mean(rhoS0MM,3);
rhoS1=mean(rhoS1MM,3);
PHIS0=mean(PHIS0MM,3);
PHIS1=mean(PHIS1MM,3);
s_f_S0=mean(s_f_S0MM,2); 
s_f_S1=mean(s_f_S1MM,2);

sigma_vS0=mean(sigma_vS0MM,2);
sigma_vS1=mean(sigma_vS1MM,2);
flt_pr=mean(flt_prMM,3);

PHIS0_mat(1:p,:) = PHIS0'; 
PHIS1_mat(1:p,:) = PHIS1';
    
STD_smoothprob=std(SMM,0,2);
STD_p00=std(p00MM,0,2);
STD_p11=std(p11MM,0,2);
STD_LS0=std(LS0MM,0,3);
STD_LS1=std(LS1MM,0,3);
STD_rhOS0=std(rhoS0MM,0,3);
STD_rhOS1=std(rhoS1MM,0,3);
STD_PHIS0=std(PHIS0MM,0,3);
STD_PHIS1=std(PHIS1MM,0,3);

STD_s_f_S0=std(s_f_S0MM,0,2); 
STD_s_f_S1=std(s_f_S1MM,0,2);

STD_sigma_vS0=std(sigma_vS0MM,0,2);
STD_sigma_vS1=std(sigma_vS1MM,0,2);
STD_flt_pr=std(flt_prMM,0,3);

figure() 

fig1=plot(year(plag+1:end),ones(1,T-plag)-smoothprob',year(plag+1:end),smoothprob');
title('Posterior Probability of States');
legend('State = 0', 'State = 1');
set(fig1(1),'LineWidth',1.5,'LineStyle','-.');
set(fig1(2),'LineWidth',1.2);
axis([1976 2015 -0.02 1.02]);
xlabel=('Year');
ylabel=('Probability');

%==============================================================================
% ---------Computing Variance, Persistence of each component ------------
%==========================================================================

var_eS0=abs(sigma_vS0./(ones(N,1)-diag(rhoS0*rhoS0')));
var_eS1=abs(sigma_vS1./(ones(N,1)-diag(rhoS1*rhoS1')));

S_F_S0_mat=zeros(plag*p,plag*p);
S_F_S0_mat(1:p,1:p)=diag(s_f_S0);
var_FYS0_mat=inv(eye(plag*p*plag*p)-kron(PHIS0_mat,PHIS0_mat))*S_F_S0_mat(:);
var_FYS0_mat=reshape(var_FYS0_mat,p*plag,p*plag);
var_FYS0=var_FYS0_mat(1:p,1:p);

S_F_S1_mat=zeros(plag*p,plag*p);
S_F_S1_mat(1:p,1:p)=diag(s_f_S1);
var_FYS1_mat=inv(eye(plag*p*plag*p)-kron(PHIS1_mat,PHIS1_mat))*S_F_S1_mat(:);
var_FYS1_mat=reshape(var_FYS1_mat,p*plag,p*plag);
var_FYS1=var_FYS1_mat(1:p,1:p);

var_commS0=diag(LS0*var_FYS0*LS0');
var_commS1=diag(LS1*var_FYS1*LS1');

var_XS0=var_commS0+var_eS0;
var_XS1=var_commS1+var_eS1;

std_XS0=sqrt(var_XS0); 
std_XS1=sqrt(var_XS1); 

std_commS0=sqrt(var_commS0);
std_commS1=sqrt(var_commS1);

std_eS0=sqrt(var_eS0);
std_eS1=sqrt(var_eS1);

r_var_comm=var_commS1./var_commS0;
r_var_e=var_eS1./var_eS0;
r_var_X=var_XS1./var_XS0;

r_std_comm=std_commS1./std_commS0;
r_std_e=std_eS1./std_eS0;
r_std_X=std_XS1./std_XS0;

pctl=[25;40;60;75];
r_std_summary_X=[mean(r_std_X);median(r_std_X);prctile(r_std_X,pctl)];
r_std_summary_comm=[mean(r_std_comm);median(r_std_comm);prctile(r_std_comm,pctl)];
r_std_summary_e=[mean(r_std_e);median(r_std_e);prctile(r_std_e,pctl)];

pers_eS0=sum(rhoS0,2);
pers_eS1=sum(rhoS1,2);

pers_S0=[PHIS0(1,1)+PHIS0(p+1,1);PHIS0(2,2)+PHIS0(p+2,2);PHIS0(3,3)+PHIS0(p+3,3)];
pers_S1=[PHIS1(1,1)+PHIS1(p+1,1);PHIS1(2,2)+PHIS1(p+2,2);PHIS1(3,3)+PHIS1(p+3,3)];

pers_commS0=zeros(N,1);pers_commS1=zeros(N,1);
s0=S0(3:end);s1=S1(3:end);
for i=1:N
    pers_commS0(i,1)=sum(olss(FY(s0,:)*LS0(i,:)',[FY(s0-1,:)*LS0(i,:)',FY(s0-2,:)*LS0(i,:)']));
    pers_commS1(i,1)=sum(olss(FY(s1,:)*LS1(i,:)',[FY(s1-1,:)*LS1(i,:)',FY(s1-2,:)*LS1(i,:)']));
end

pers_XS0=zeros(N,1);pers_XS1=zeros(N,1);
for i=1:N
    pers_XS0(i,1)=sum(olss(X(s0,i),[X(s0-1,i),X(s0-2,i)]));
    pers_XS1(i,1)=sum(olss(X(s1,i),[X(s1-1,i),X(s1-2,i)]));
end

r_pers_comm=pers_commS1./pers_commS0;
r_pers_e=pers_eS1./pers_eS0;
r_pers_X=pers_XS1./pers_XS0;

r_pers_summary_X=[mean(r_pers_X);median(r_pers_X);prctile(r_pers_X,pctl)];
r_pers_summary_comm=[mean(r_pers_comm);median(r_pers_comm);prctile(r_pers_comm,pctl)];
r_pers_summary_e=[mean(r_pers_e);median(r_pers_e);prctile(r_pers_e,pctl)];

%==============================================================================
% ---------Computing IRF based on average parameter value ------------
%==========================================================================
%=== IRF of Macro Shocks
 PHIS0_mat(1:p,:) = PHIS0'; 
 PHIS1_mat(1:p,:) = PHIS1';
 bigaS0 = PHIS0_mat;
 bigaS1 = PHIS1_mat;
            
 shockS0=eye(p);
 shockS1=eye(p);
            
 imprespS0 = zeros(p,p*nhor);  imprespS1 = zeros(p,p*nhor);
 imprespS0(1:p,1:p) = shockS0;   imprespS1(1:p,1:p) = shockS1;
 bigaiS0 = bigaS0;   bigaiS1 = bigaS1;
            
 for j = 1:nhor-1
    imprespS0(:,j*p+1:(j+1)*p) = bigj*bigaiS0*bigj'*shockS0;
    bigaiS0 = bigaiS0*bigaS0;
    imprespS1(:,j*p+1:(j+1)*p) = bigj*bigaiS1*bigj'*shockS1;
    bigaiS1 = bigaiS1*bigaS1;
 end
            
             
 imp_mS0 = zeros(p,nhor); imp_mS1 = zeros(p,nhor);
 jj=0;
 for ij = 1:nhor
    jj = jj + p; 
    imp_mS0(:,ij) = imprespS0(:,jj); 
    imp_mS1(:,ij) = imprespS1(:,jj); 
 end
  impS0 = LS0*imp_mS0; 
  impS1 = LS1*imp_mS1;
 
  imp_c1S0 = zeros(p,nhor); imp_c1S1 = zeros(p,nhor);
  jj=-2;
  for ij = 1:nhor
      jj = jj + p; 
      imp_c1S0(:,ij) = imprespS0(:,jj); 
      imp_c1S1(:,ij) = imprespS1(:,jj); 
  end
   impc1S0 = LS0*imp_c1S0; 
   impc1S1 = LS1*imp_c1S1;
            
   
imp_c2S0 = zeros(p,nhor); imp_c2S1 = zeros(p,nhor);
  jj=-1;
  for ij = 1:nhor
      jj = jj + p; 
      imp_c2S0(:,ij) = imprespS0(:,jj); 
      imp_c2S1(:,ij) = imprespS1(:,jj); 
  end
 impc2S0 = LS0*imp_c2S0; 
 impc2S1 = LS1*imp_c2S1;
            
 eshockS0=eye(N);
 eshockS1=eye(N);

imp_e_S0=zeros(N,nhor);
imp_e_S1=zeros(N,nhor);
for j=1:N
    imp_e_S0(j,1)=eshockS0(j,j);
   imp_e_S1(j,1)=eshockS1(j,j);
 end
imp_e_S0(:,2)=imp_e_S0(:,1).*rhoS0(:,1);
imp_e_S1(:,2)=imp_e_S1(:,1).*rhoS1(:,1);

for t=3:nhor
    imp_e_S0(:,t)=imp_e_S0(:,t-1).*rhoS0(:,1)+imp_e_S0(:,t-2).*rhoS0(:,2);
    imp_e_S1(:,t)=imp_e_S1(:,t-1).*rhoS1(:,1)+imp_e_S1(:,t-2).*rhoS1(:,2);
end

% == Compute sector mean and median response==

impS0mean=mean(impS0,1); 
impS1mean=mean(impS1,1);

impS0median=median(impS0,1); 
impS1median=median(impS1,1);

imp_e_S0mean=mean(imp_e_S0,1);
imp_e_S1mean=mean(imp_e_S1,1);

imp_e_S0median=median(imp_e_S0,1);
imp_e_S1median=median(imp_e_S1,1);

for i=1:152
    impS0n(i,:)=impS0(i,:);
    impS1n(i,:)=impS1(i,:).*sum(abs(impS0mean))./sum(abs(impS1mean));
    imp_e_S0n(i,:)=imp_e_S0(i,:);
    imp_e_S1n(i,:)=imp_e_S1(i,:);
end

impS0n_ave=mean(impS0n,1); 
impS1n_ave=mean(impS1n,1);

impS0n_med=median(impS0n,1); 
impS1n_med=median(impS1n,1);

imp_e_S0n_ave=mean(imp_e_S0n,1);
imp_e_S1n_ave=mean(imp_e_S1n,1);

imp_e_S0n_med=median(imp_e_S0n,1);
imp_e_S1n_med=median(imp_e_S1n,1);

figure() 

subplot(221);
plot1 = plot(1:nhor,impS0n_ave,1:nhor, impS1n_ave);
title('(a) Mean Response to FFR Shock')
set(plot1(1),'LineWidth',2,'LineStyle','-.');
set(plot1(2),'LineWidth',2);
legend('Mean, State=0','Mean, State=1');
axis([0 60 0 0.55])

subplot(222);
plot1 = plot(1:nhor,impS0n_med,1:nhor,impS1n_med);
title('(b) Median Response to FFR Shock')
set(plot1(1),'LineWidth',2,'LineStyle','-.');
set(plot1(2),'LineWidth',2);
legend('Median, State=0','Median, State=1');
axis([0 60 0 0.55])

subplot(223);
plot1 = plot(1:nhor,imp_e_S0n_ave,1:nhor, imp_e_S1n_ave);
title('(c) Mean Response to Idiosyncratic Shock')
set(plot1(1),'LineWidth',2,'LineStyle','-.');
set(plot1(2),'LineWidth',2);
legend('Mean, State=0','Mean, State=1');

subplot(224);
plot1 = plot(1:nhor,imp_e_S0n_med,1:nhor,imp_e_S1n_med);
title('(d) Median Response to Idiosyncratic Shock')
set(plot1(1),'LineWidth',2,'LineStyle','-.');
set(plot1(2),'LineWidth',2);
legend('Median, State=0','Median, State=1');

for t=1:nhor
    r_impS0mean(t)=sum(abs(impS0mean(1:t)))./sum(abs(impS0mean));
    r_impS1mean(t)=sum(abs(impS1mean(1:t)))./sum(abs(impS1mean));
    r_impS0median(t)=sum(abs(impS0median(1:t)))./sum(abs(impS0median));
    r_impS1median(t)=sum(abs(impS1median(1:t)))./sum(abs(impS1median));
    r_impc1S0mean(t)=sum(abs(impc1S0mean(1:t)))./sum(abs(impc1S0mean));
    r_impc1S1mean(t)=sum(abs(impc1S1mean(1:t)))./sum(abs(impc1S1mean));
    r_impc1S0median(t)=sum(abs(impc1S0median(1:t)))./sum(abs(impc1S0median));
    r_impc1S1median(t)=sum(abs(impc1S1median(1:t)))./sum(abs(impc1S1median));
    r_impc2S0mean(t)=sum(abs(impc2S0mean(1:t)))./sum(abs(impc2S0mean));
    r_impc2S1mean(t)=sum(abs(impc2S1mean(1:t)))./sum(abs(impc2S1mean));
    r_impc2S0median(t)=sum(abs(impc2S0median(1:t)))./sum(abs(impc2S0median));
    r_impc2S1median(t)=sum(abs(impc2S1median(1:t)))./sum(abs(impc2S1median));
    r_imp_e_S0mean(t)=sum(abs(imp_e_S0mean(1:t)))./sum(abs(imp_e_S0mean)); 
    r_imp_e_S1mean(t)=sum(abs(imp_e_S1mean(1:t)))./sum(abs(imp_e_S1mean));
    r_imp_e_S0median(t)=sum(abs(imp_e_S0median(1:t)))./sum(abs(imp_e_S0median)); 
    r_imp_e_S1median(t)=sum(abs(imp_e_S1median(1:t)))./sum(abs(imp_e_S1median));
end

figure() 

subplot(221);
plot1 = plot(1:nhor,r_impS0mean,1:nhor, r_impS1mean);
title('Mean Response to FFR Shock')
set(plot1(1),'LineWidth',2,'LineStyle','-.');
set(plot1(2),'LineWidth',2);
legend('Mean, S=0','Mean, S=1');

subplot(222);
plot1 = plot(1:nhor,r_impS0median,1:nhor,r_impS1median);
title('Median Response to FFR Shock')
set(plot1(1),'LineWidth',2,'LineStyle','-.');
set(plot1(2),'LineWidth',2);
legend('Median, S=0','Median, S=1');

subplot(223);
plot1 = plot(1:nhor,r_imp_e_S0mean,1:nhor, r_imp_e_S0mean);
title('Mean Response to Idiosyncratic Shock')
set(plot1(1),'LineWidth',2,'LineStyle','-.');
set(plot1(2),'LineWidth',2);
legend('Mean, S=0','Mean, S=1');

subplot(224);
plot1 = plot(1:nhor,r_imp_e_S0median,1:nhor,r_imp_e_S0median);
title('Median Response to Idiosyncratic Shock')
set(plot1(1),'LineWidth',2,'LineStyle','-.');
set(plot1(2),'LineWidth',2);
legend('Median, S=0','Median, S=1');
