clear all;
close all;

load('result_PCE.mat'); 

%==============================================================================
% ------------------Computing Sample Parameter Moments -----------------------------
%==========================================================================

smoothprob=mean(SMM,2);
p00=mean(p00MM,2);
p11=mean(p11MM,2);
LS0=mean(LS0MM,3);
LS1=mean(LS1MM,3);
rhoS0=mean(rhoS0MM,3);
rhoS1=mean(rhoS1MM,3);
PHIS0=mean(PHIS0MM,3);
PHIS1=mean(PHIS1MM,3);
s_f_S0=mean(s_f_S0MM,2); 
s_f_S1=mean(s_f_S1MM,2);
sigma_vS0=mean(sigma_vS0MM,2);
sigma_vS1=mean(sigma_vS1MM,2);
flt_pr=mean(flt_prMM,3);

PHIS0_mat(1:p,:) = PHIS0'; 
PHIS1_mat(1:p,:) = PHIS1';

STD_smoothprob=std(SMM,0,2);
STD_p00=std(p00MM,0,2);
STD_p11=std(p11MM,0,2);
STD_LS0=std(LS0MM,0,3);
STD_LS1=std(LS1MM,0,3);
STD_rhOS0=std(rhoS0MM,0,3);
STD_rhOS1=std(rhoS1MM,0,3);
STD_PHIS0=std(PHIS0MM,0,3);
STD_PHIS1=std(PHIS1MM,0,3);
STD_s_f_S0=std(s_f_S0MM,0,2); 
STD_s_f_S1=std(s_f_S1MM,0,2);

STD_sigma_vS0=std(sigma_vS0MM,0,2);
STD_sigma_vS1=std(sigma_vS1MM,0,2);
STD_flt_pr=std(flt_prMM,0,3);

%==============================================================================
% ---------Computing Variance, Persistence of each component ------------
%==========================================================================

var_eS0=abs(sigma_vS0./(ones(N,1)-diag(rhoS0*rhoS0')));
var_eS1=abs(sigma_vS1./(ones(N,1)-diag(rhoS1*rhoS1')));

S_F_S0_mat=zeros(plag*p,plag*p);
S_F_S0_mat(1:p,1:p)=diag(s_f_S0);
var_FYS0_mat=inv(eye(plag*p*plag*p)-kron(PHIS0_mat,PHIS0_mat))*S_F_S0_mat(:);
var_FYS0_mat=reshape(var_FYS0_mat,p*plag,p*plag);
var_FYS0=var_FYS0_mat(1:p,1:p);

S_F_S1_mat=zeros(plag*p,plag*p);
S_F_S1_mat(1:p,1:p)=diag(s_f_S1);
var_FYS1_mat=inv(eye(plag*p*plag*p)-kron(PHIS1_mat,PHIS1_mat))*S_F_S1_mat(:);
var_FYS1_mat=reshape(var_FYS1_mat,p*plag,p*plag);
var_FYS1=var_FYS1_mat(1:p,1:p);

var_commS0=diag(LS0*var_FYS0*LS0');
var_commS1=diag(LS1*var_FYS1*LS1');

var_XS0=var_commS0+var_eS0;
var_XS1=var_commS1+var_eS1;

std_XS0=sqrt(var_XS0); 
std_XS1=sqrt(var_XS1); 

std_commS0=sqrt(var_commS0);
std_commS1=sqrt(var_commS1);

std_eS0=sqrt(var_eS0);
std_eS1=sqrt(var_eS1);

r_var_comm=var_commS1./var_commS0;
r_var_e=var_eS1./var_eS0;
r_var_X=var_XS1./var_XS0;

r_std_comm=std_commS1./std_commS0;
r_std_e=std_eS1./std_eS0;
r_std_X=std_XS1./std_XS0;

%==============================================================================
% ---------Computing IRF based on average parameter value ------------
%==========================================================================

 PHIS0_mat(1:p,:) = PHIS0'; 
 PHIS1_mat(1:p,:) = PHIS1';
 bigaS0 = PHIS0_mat;
 bigaS1 = PHIS1_mat;
            
 shockS0=eye(p);
 shockS1=eye(p);
 
 imprespS0 = zeros(p,p*nhor);  imprespS1 = zeros(p,p*nhor);
 imprespS0(1:p,1:p) = shockS0;   imprespS1(1:p,1:p) = shockS1;
 bigaiS0 = bigaS0;   bigaiS1 = bigaS1;
            
 for j = 1:nhor-1
     imprespS0(:,j*p+1:(j+1)*p) = bigj*bigaiS0*bigj'*shockS0;
     bigaiS0 = bigaiS0*bigaS0;
                
     imprespS1(:,j*p+1:(j+1)*p) = bigj*bigaiS1*bigj'*shockS1;
     bigaiS1 = bigaiS1*bigaS1;
 end
            
 imp_mS0 = zeros(p,nhor); imp_mS1 = zeros(p,nhor);
 jj=0;
 for ij = 1:nhor
     jj = jj + p; 
     imp_mS0(:,ij) = imprespS0(:,jj); 
     imp_mS1(:,ij) = imprespS1(:,jj); 
 end
  impS0 = LS0*imp_mS0; 
  impS1 = LS1*imp_mS1;
            
 imp_c1S0 = zeros(p,nhor); imp_c1S1 = zeros(p,nhor);
 jj=-2;
 for ij = 1:nhor
    jj = jj + p; 
    imp_c1S0(:,ij) = imprespS0(:,jj); 
    imp_c1S1(:,ij) = imprespS1(:,jj); 
 end
 impc1S0 = LS0*imp_c1S0; 
 impc1S1 = LS1*imp_c1S1;
            
 imp_c2S0 = zeros(p,nhor); imp_c2S1 = zeros(p,nhor);
 jj=-1;
 for ij = 1:nhor
    jj = jj + p; 
    imp_c2S0(:,ij) = imprespS0(:,jj); 
    imp_c2S1(:,ij) = imprespS1(:,jj); 
 end
 impc2S0 = LS0*imp_c2S0; 
 impc2S1 = LS1*imp_c2S1;
            
eshockS0=eye(N);
eshockS1=eye(N);

 imp_e_S0=zeros(N,nhor);
 imp_e_S1=zeros(N,nhor);
 for j=1:N
     imp_e_S0(j,1)=eshockS0(j,j);
     imp_e_S1(j,1)=eshockS1(j,j);
 end
 imp_e_S0(:,2)=imp_e_S0(:,1).*rhoS0(:,1);
 imp_e_S1(:,2)=imp_e_S1(:,1).*rhoS1(:,1);
 for t=3:nhor
     imp_e_S0(:,t)=imp_e_S0(:,t-1).*rhoS0(:,1)+imp_e_S0(:,t-2).*rhoS0(:,2);
     imp_e_S1(:,t)=imp_e_S1(:,t-1).*rhoS1(:,1)+imp_e_S1(:,t-2).*rhoS1(:,2);
 end
     
 for i=1:N
    imp_e_S0(i,:)=(cumsum(imp_e_S0(i,:),2)); 
    imp_e_S1(i,:)=(cumsum(imp_e_S1(i,:),2));
    
    impS0(i,:)=(cumsum(impS0(i,:),2));
    impS1(i,:)=(cumsum(impS1(i,:),2));
 end
 
impS1=impS1./repmat(impS1(:,60),1,nhor).*repmat(impS0(:,60),1,nhor); 
imp_e_S1=imp_e_S1./repmat(imp_e_S1(:,60),1,nhor).*repmat(imp_e_S0(:,60),1,nhor);

%== Calculating RRS

for t=1:nhor
    RRS(:,t)=sum(abs(impS1(:,1:t)),2)./sum(abs(impS0(:,1:t)),2); %N x nhor
    RRS_e(:,t)=sum(abs(imp_e_S1(:,1:t)),2)./sum(abs(imp_e_S0(:,1:t)),2);
end

RRS3=RRS(:,3); 
RRS6=RRS(:,6); 
RRS12=RRS(:,12);
RRS24=RRS(:,24);

RRS2_e=RRS_e(:,2); 
RRS3_e=RRS_e(:,3); 
RRS6_e=RRS_e(:,6); 
RRS12_e=RRS_e(:,12);

[corr12_comm,corrcomm12_int,corr12commR,corr12commRint,corr12_stat_comm] = regress(log(RRS12),[ones(N,1),log(r_std_comm)]);
[corr6_comm,corrcomm6_int,corr6commR,corr6commRint,corr6_stat_comm] = regress(log(RRS6),[ones(N,1),log(r_std_comm)]);
[corr3_comm,corrcomm3_int,corr3commR,corr3commRint,corr3_stat_comm] = regress(log(RRS3),[ones(N,1),log(r_std_comm)]);
[corr24_comm,corrcomm24_int,corr24commR,corr24commRint,corr24_stat_comm] = regress(log(RRS24),[ones(N,1),log(r_std_comm)]);
[corr12_e,corre12_int,corr12eR,corr12eRint,corr12_stat_e] = regress(log(RRS12_e),[ones(N,1),log(r_std_e)]);
[corr2_e,corre2_int,corr2eR,corr2eRint,corr2_stat_e] = regress(log(RRS2_e),[ones(N,1),log(r_std_e)]);
[corr6_e,corre6_int,corr6eR,corr6eRint,corr6_stat_e] = regress(log(RRS6_e),[ones(N,1),log(r_std_e)]);
[corr3_e,corre3_int,corr3eR,corr3eRint,corr3_stat_e] = regress(log(RRS3_e),[ones(N,1),log(r_std_e)]);



