function fun = RI_fixedpoint(yt,a,b,m,n,kappa) 

% Inputs: 
% yt: a matrix of guess for (c, d, f, g, k1,k2, lagrangian)
% a: MA representation coeff of the aggregate component of optimal price
% b: MA representation coeff of the idio component of optimal price
% m: max length of vectors to be used in linear projection. m=(n-1)*10
% n: order of the MA representation. n =length(a)=length(b)
% kappa: total information capacity


c = yt(1:n,1);
d = yt(n+1:2*n,1);
f = yt(2*n+1:3*n,1);
g = yt(3*n+1:4*n,1);
kappa1 = yt(end-2,1);
kappa2 = yt(end-1,1);
lag = yt(end,1);

% aggregate part
B = zeros(2*m+1,2*m+n); C = zeros(2*m+1,2*m+n);
for j = 1:2*m+1;
    B(j,j:j-1+length(c)) = c'; C(j,j:j-1+length(d)) = d'; 
end;
btilde = [zeros(2*m+1-m-length(c),1); flipud(c); zeros(m,1)]; 
beta = (B*B' + C*C')\btilde;
Ctilde = zeros(2*m+1-length(d)+1,2*m+1);
for j = 1:2*m+1-length(d)+1;
    Ctilde(j,j:j-1+length(d)) = d'; 
end;
alpha = (Ctilde*(B*B' + C*C')*Ctilde')\(Ctilde*btilde);
beta = flipud(beta(1:m+1,:));
beta = beta(1:n,:);
cc = a - c - (lag*(0.5/log(2))).*beta;
alpha = flipud(alpha(1:m+1,:));
alpha = alpha(1:n+n-1,:);

for j = 1:n;
    dd(j,:) = d(j,:) - (lag*(0.5/log(2))).*c'*alpha(j:j+length(c)-1,:);
end;
con1 = -(1./(4*pi*log(2))).*quad(@infoflow_integral,-pi,pi,[],[],c,d,length(c)) - kappa1; 

% idiosyncratic part
B = zeros(2*m+1,2*m+n); C = zeros(2*m+1,2*m+n);
for j = 1:2*m+1;
    B(j,j:j-1+length(f)) = f'; C(j,j:j-1+length(g)) = g';
end;
btilde = [zeros(2*m+1-m-length(f),1); flipud(f); zeros(m,1)];
beta = (B*B' + C*C')\btilde;
Ctilde = zeros(2*m+1-length(g)+1,2*m+1);
for j = 1:2*m+1-length(g)+1;
    Ctilde(j,j:j-1+length(g)) = g';
end;
alpha = (Ctilde*(B*B' + C*C')*Ctilde')\(Ctilde*btilde);
beta = flipud(beta(1:m+1,:));
beta = beta(1:n,:);
ff = b - f - (lag*(0.5/log(2))).*beta; 
alpha = flipud(alpha(1:m+1,:));
alpha = alpha(1:n+n-1,:);

for j = 1:n;
    gg(j,:) = g(j,:) - (lag*(0.5/log(2))).*f'*alpha(j:j+length(f)-1,:); 
end;

con2 = -(1./(4*pi*log(2))).*quad(@infoflow_integral,-pi,pi,[],[],f,g,length(f)) - kappa2; 
con3 = kappa1 + kappa2 - kappa;

fun = [cc; dd; con1; ff; gg; con2; con3];  

