
load('combinesimul.mat');

N=size(kappa,3); 
I=size(kappa,2); 
L=10; 
L1=5; 
k=4;
T2=T1-L1; 
L_ini=L;
m = (L-1)*3;
T=40; 

recindex=[2*L1+k*L1+1:2*L1+2*k*L1 2*L1+3*k*L1+1:2*L1+4*k*L1]'; 
expindex=[1:2*L1+k*L1 2*L1+2*k*L1+1:2*L1+3*k*L1 2*L1+4*k*L1+1:T1]';
recindexchop=recindex-L1; 
expindexchop=expindex(L1+1:end)-L1;

t1=2*L1+k*L1-10; 
t2=2*L1+2*k*L1-10; 
t1_chop=t1-L1; 
t2_chop=t2-L1;

Lperiod= [t1-9:t1+30]'; 
Hperiod= [t2-9:t2+30]'; 
Lperiodchop= [t1_chop-9:t1_chop+30]'; 
Hperiodchop= [t2_chop-9:t2_chop+30]'; 

kappaA_H=kappaA(Hperiodchop,:,:);
kappaA_L=kappaA(Lperiodchop,:,:);
kappaS_H=kappaS(Hperiodchop,:,:);
kappaS_L=kappaS(Lperiodchop,:,:);


sigma_LA = 1;  
sigma_HA = 3.5*sigma_LA; 
sigma_LS = 5.9*sigma_LA;
sigma_HS = 5.8*sigma_LA;  
sigmaA(expindex)= sigma_LA; sigmaS(expindex)= sigma_LS;
sigmaA(recindex) = sigma_HA; sigmaS(recindex) = sigma_HS;

rhoA_L=0.85; 
rhoA_H=0.85;
rhoS_L=0.01;
rhoS_H=0.01; 
rhoA(expindex)= rhoA_L; rhoA(recindex)= rhoA_H;
rhoS(expindex)= rhoS_L; rhoS(recindex)= rhoS_H;


a=zeros(T1,L); 
b=zeros(T1,L); 
for t=L+1:T1
      a(t,1)=sigmaA(t);b(t,1)=sigmaS(t);
   for l=2:L
      a(t,l)= a(t,l-1)/sigmaA(t-l+2)*sigmaA(t-l+1)*rhoA(t-l+2);
      b(t,l)= b(t,l-1)/sigmaS(t-l+2)*sigmaS(t-l+1)*rhoS(t-l+2);
   end
end


N_sim=N; 
I_sim=I; 

Ashock = normrnd(0,1,T1,N_sim);
Sshock = normrnd(0,1,T1,I_sim,N_sim); 
Ashock(t2,:)=1;
Sshock(t2,:,:)=1;

Anoise = normrnd(0,1,T1,I_sim,N_sim);
Snoise = normrnd(0,1,T1,I_sim,N_sim);

p_diamA = zeros(T1,N_sim); p_diamS = zeros(T1,I_sim,N_sim);
for t=L+1:T1
    for n=1:N_sim
        p_diamA(t,n)= a(t,:)*flipud(squeeze(Ashock(t-L:t-1,n)));
        for i=1:I_sim
            p_diamS(t,i,n)= b(t,:)*flipud(squeeze(Sshock(t-L:t-1,i,n)));
        end
    end
end

a=a(L1+1:end,:); 
b=b(L1+1:end,:);
p_diamA = p_diamA(L1+1:end,:);
p_diamS = p_diamS(L1+1:end,:,:);
ave_pdiamA=mean(p_diamA,2);
ave_pdiamS=mean(mean(p_diamS,3),2);

options1 = optimset('LargeScale','Off','MaxIter',20,'TolFun',0.01,'TolX',0.01);
c_H=zeros(T2,L,I,N); d_H=zeros(T2,L,I,N); f_H=zeros(T2,L,I,N); g_H=zeros(T2,L,I,N);
pA_H=zeros(T2,I,N); pS_H=zeros(T2,I,N);
c_L=zeros(T2,L,I,N); d_L=zeros(T2,L,I,N); f_L=zeros(T2,L,I,N); g_L=zeros(T2,L,I,N);
pA_L=zeros(T2,I,N); pS_L=zeros(T2,I,N);

tic;
for t=Hperiodchop(1):Hperiodchop(T)
    for i=1:I
        for n=1:N
            [c_H(t,:,i,n),d_H(t,:,i,n)]=opsig(kappaA(t,i,n),a(t,:)',L,m,options1); 
            f_H(t,:,i,n)=(1-2^(-2*kappaS(t,i,n)))*b(t,:)'; 
            g_H(t,1,i,n)=2^(-2*kappaS(t,i,n))*sqrt(sum(b(t,:).^2,2));
        end
    end
    t
end

for t=Lperiodchop(1):Lperiodchop(T)
    for i=1:I
        for n=1:N
            [c_L(t,:,i,n),d_L(t,:,i,n)]=opsig(kappaA(t,i,n),a(t+Hperiodchop(1)-Lperiodchop(1),:)',L,m,options1); 
            f_L(t,:,i,n)=(1-2^(-2*kappaS(t,i,n)))*b(t+Hperiodchop(1)-Lperiodchop(1),:)'; 
            g_L(t,1,i,n)=2^(-2*kappaS(t,i,n))*sqrt(sum(b(t,:).^2,2));
        end
    end
    t
end

toc;

c_H_sim=c_H;
c_L_sim=c_L;
d_H_sim=d_H;
d_L_sim=d_L;
f_H_sim=f_H;
f_L_sim=f_L;
g_H_sim=g_H;
g_L_sim=g_L;

for t=Hperiodchop(1):Hperiodchop(T)
    for n=1:N_sim
        for i=1:I_sim
             pA_H(t,i,n)= squeeze(c_H_sim(t,:,i,n))*flipud(squeeze(Ashock(t-L+L1:t-1+L1,n)))+ squeeze(d_H_sim(t,:,i,n))*flipud(squeeze(Anoise(t-L+L1:t-1+L1,i,n)));
             pS_H(t,i,n)= squeeze(f_H_sim(t,:,i,n))*flipud(squeeze(Sshock(t-L+L1:t-1+L1,n)))+ squeeze(g_H_sim(t,:,i,n))*flipud(squeeze(Snoise(t-L+L1:t-1+L1,i,n)));
        end
    end
end

for t=Lperiodchop(1):Lperiodchop(T)
    for n=1:N_sim
        for i=1:I_sim
             pA_L(t,i,n)= squeeze(c_L_sim(t,:,i,n))*flipud(squeeze(Ashock(t-L+L1+Hperiodchop(1)-Lperiodchop(1):t-1+L1+Hperiodchop(1)-Lperiodchop(1),n)))+ squeeze(d_L_sim(t,:,i,n))*flipud(squeeze(Anoise(t-L+L1+Hperiodchop(1)-Lperiodchop(1):t-1+L1+Hperiodchop(1)-Lperiodchop(1),i,n)));
             pS_L(t,i,n)= squeeze(f_L_sim(t,:,i,n))*flipud(squeeze(Sshock(t-L+L1+Hperiodchop(1)-Lperiodchop(1):t-1+L1+Hperiodchop(1)-Lperiodchop(1),n)))+ squeeze(g_L_sim(t,:,i,n))*flipud(squeeze(Snoise(t-L+L1+Hperiodchop(1)-Lperiodchop(1):t-1+L1+Hperiodchop(1)-Lperiodchop(1),i,n)));
        end
    end
end

pA_H=pA_H(Hperiodchop,:,:);
pA_L=pA_L(Lperiodchop,:,:);
pS_H=pS_H(Hperiodchop,:,:);
pS_L=pS_L(Lperiodchop,:,:);

ave_i_pA_H=mean(pA_H,2);ave_i_pS_H=mean(pS_H,2);
ave_pA_H=mean(ave_i_pA_H,3);ave_pS_H=mean(ave_i_pS_H,3);
ave_i_pA_L=mean(pA_L,2);ave_i_pS_L=mean(pS_L,2);
ave_pA_L=mean(ave_i_pA_L,3);ave_pS_L=mean(ave_i_pS_L,3);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
timeplot = 1:T;
timeplot=timeplot';
ave_pdiamA=ave_pdiamA(Hperiodchop);
ave_pdiamS=ave_pdiamS(Hperiodchop);

figure()

plot1=plot(timeplot,ave_pA_H,timeplot,ave_pA_L,timeplot,ave_pdiamA);
title('Price Response (Aggregate)');
xlabel('time');
ylabel('Price');
legend('actual_H','actual_L','optimal');
set(plot1(3),'Marker','.')

figure()

plot2=plot(timeplot,ave_pS_H,timeplot,ave_pS_L,timeplot,ave_pdiamS);
title('Price Response (S-S)');
xlabel('time');
ylabel('Price');
legend('actual_H','actual_L','optimal');
set(plot2(3),'Marker','.')

save('presp.mat');